import { ExcessGenerationRepository, NewExcessGeneration } from './repositories/ExcessGeneration/ExcessGeneration.repository';
import { LeftoverConsumptionRepository, NewLeftoverConsumption } from './repositories/LeftoverConsumption/LeftoverConsumption.repository';
import { MatchResultRepository, NewMatchResult } from './repositories/MatchResult/MatchResult.repository';
import { IConsumption, IGeneration, IMatch, IMatchingInput, IMatchingOutput, ITimeFrame } from './interfaces';
import { CertificateService, IClaimCommand } from '@energyweb/origin-247-certificate';
export interface IClaimInput {
    algorithmFn: (input: IMatchingInput) => IMatchingOutput;
    claimCustomizationFn: (input: IMatch<IConsumption, IGeneration>[]) => IClaimCommand[];
    data: IMatchingInput;
    timeframe: ITimeFrame;
}
export interface IRaport {
    matches: NewMatchResult[];
    leftoverConsumptions: NewLeftoverConsumption[];
    excessGenerations: NewExcessGeneration[];
}
export declare class ClaimService {
    private matchResultRepo;
    private leftoverConsumptionRepo;
    private excessGenerationRepo;
    private certificateService;
    constructor(matchResultRepo: MatchResultRepository, leftoverConsumptionRepo: LeftoverConsumptionRepository, excessGenerationRepo: ExcessGenerationRepository, certificateService: CertificateService<unknown>);
    claim(input: IClaimInput): Promise<IRaport>;
    private createRaport;
    private createLogs;
    private createMatchResultLogs;
    private createLeftoverConsumptionLogs;
    private createExcessGenerationLogs;
    private filterZeroVolumeMatches;
}
